routes/web.php
<?php

use App\Http\Controllers\Admin\CompanyController;
use App\Http\Controllers\Admin\InstitutionController;
use App\Http\Controllers\Admin\User\UserAttachOrganizationFormController;
use App\Http\Controllers\Admin\User\UserAttachOrganizationUpdateController;
use App\Http\Controllers\CouponController;
use App\Http\Controllers\DashboardController;
use App\Http\Controllers\Admin\MenuController;
use App\Http\Controllers\Admin\PermissionController;
use App\Http\Controllers\Admin\ProfileController;
use App\Http\Controllers\Admin\UserController;
use App\Http\Controllers\Admin\CityController;
use App\Http\Controllers\Donate\DonateFormController;
use App\Http\Controllers\Donate\DonateStoreController;
use App\Http\Controllers\DonationController;
use App\Http\Controllers\RansomController;
use App\Http\Controllers\RescuedCoupon\RescuedCouponFormController;
use App\Http\Controllers\RescuedCoupon\RescuedCouponStoreController;
use Illuminate\Support\Facades\Route;
use App\Http\Controllers\Admin\RoleController;
/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/


Auth::routes();

Route::group(['middleware' => 'auth',], function () {

    Route::redirect('/', '/dashboard');
    Route::get('/dashboard', [DashboardController::class, 'index'])->name('home');

    Route::resource('roles', RoleController::class, ['parameters' => ['roles' => 'role']]);
    Route::resource('users', UserController::class, ['parameters' => ['users' => 'user']]);
    Route::resource('menus', MenuController::class, ['parameters' => ['menus' => 'menu']]);
    Route::resource('permissions', PermissionController::class, ['parameters' => ['permissions' => 'permission']]);
    Route::resource('institutions', InstitutionController::class, ['parameters' => ['permissions' => 'institution']]);
    Route::resource('companies', CompanyController::class, ['parameters' => ['permissions' => 'company']]);
    Route::resource('coupons', CouponController::class, ['parameters' => ['permissions' => 'coupon']]);
    Route::resource('donations',DonationController::class, ['parameters' => ['permissions' => 'donations']])->except(['edit', 'update', 'destroy']);
    Route::resource('rescues', RansomController::class, ['parameters' => ['permissions' => 'rescue']])->except(['destroy']);

    Route::get('profile', [ProfileController::class, 'edit'])->name('profile.edit');
    Route::put('profile', [ProfileController::class, 'update'])->name('profile.update');

    Route::get('user/{user}/attach', UserAttachOrganizationFormController::class)->name('user.attach.edit');
    Route::put('user/{user}/attach', UserAttachOrganizationUpdateController::class)->name('user.attach.update');

    Route::get('rescued-coupon', RescuedCouponFormController::class)->name('rescued-coupon.create');
    Route::post('rescued-coupon', RescuedCouponStoreController::class)->name('rescued-coupon.store');

    Route::get('donate', DonateFormController::class)->name('donate.create');
    Route::post('donate', DonateStoreController::class)->name('donate.store');

});

app/Http/Controllers/DashboardController.php
<?php

namespace App\Http\Controllers;

use App\Models\User;
use App\Repositories\Contracts\CompanyRepositoryInterface;
use App\Repositories\Contracts\CouponRepositoryInterface;
use App\Repositories\Contracts\DonationRepositoryInterface;
use App\Repositories\Contracts\InstitutionRepositoryInterface;
use App\Services\Dashboard\Contracts\AdminPanelServiceInterface;
use App\Services\Wallet\Contracts\WalletCacheServiceInterface;
use Illuminate\Support\Facades\Auth;

class DashboardController extends Controller
{
    const MAX_CARDS_LIST = 3;
    const MAX_LAST_DONATIONS = 3;
    const MAX_LAST_COUPONS = 5;

    private WalletCacheServiceInterface $walletCacheService;
    private InstitutionRepositoryInterface $instituionRepository;
    private CompanyRepositoryInterface $companyRepository;
    private DonationRepositoryInterface $donationRepository;
    private CouponRepositoryInterface $couponRepository;
    private AdminPanelServiceInterface $adminPanelService;

    private string $route = "home.";
    private string $viewDir = 'dashboard.';
    private string $titlePage = 'Painel de Controle';

    public array $page = [];

    /**
     * Create a new controller instance.
     *
     * @return void
     */

    public function __construct(
        WalletCacheServiceInterface $walletCacheService,
        InstitutionRepositoryInterface $instituionRepository,
        CompanyRepositoryInterface $companyRepository,
        DonationRepositoryInterface $donationRepository,
        CouponRepositoryInterface $couponRepository,
        AdminPanelServiceInterface $adminPanelService,
    )
    {
        $this->walletCacheService = $walletCacheService;
        $this->instituionRepository = $instituionRepository;
        $this->companyRepository = $companyRepository;
        $this->donationRepository = $donationRepository;
        $this->couponRepository = $couponRepository;
        $this->adminPanelService = $adminPanelService;

        $this->middleware('auth');
        $this->page = [
            'titlePage' => $this->titlePage,
            'route' => $this->route,
            'viewDir' => $this->viewDir,
            'breadcrumb' => [
                [
                    'title' => 'Inicio',
                    'url' => route('home')
                ],
                [
                    'title' => $this->titlePage,
                    'url' => null
                ],
            ]
        ];

        $this->middleware('permission:dashboard-list');

    }

    /**
     * Show the application admin.
     *
     * @return \Illuminate\Contracts\Support\Renderable
     */
    public function index()
    {
        $user = Auth::user();
        if ($user->hasRole('donor')) {
            return $this->dashboardDonor($user);
        }

        if ($user->hasRole('institution')) {
            return $this->dashboardInstitution($user);
        }

        if ($user->hasRole('partner')) {
            return $this->dashboardCompany($user);
        }

        if ($user->hasRole('admin')) {
            return $this->dashboardAdmin($user);
        }

        return view($this->viewDir.'index')->with(['page' => $this->page, 'data' => '']);
    }

    private function dashboardDonor(User $user)
    {
        $data['availablePoints'] = $this->walletCacheService->getSumAvailableBalanceByUser($user->id);
        $data['institutions'] = $this->instituionRepository->getAll()->shuffle()->take(self::MAX_CARDS_LIST);
        $data['companies'] = $this->companyRepository->getAll()->shuffle()->take(self::MAX_CARDS_LIST);

        return view($this->viewDir.'index-donor')->with(['page' => $this->page, 'data' => $data]);
    }

    private function dashboardInstitution(User $user)
    {
        $institution = $user->institution;
        $data['availablePoints'] = $this->donationRepository->sumAvailablePoints($institution->id);
        $data['lastDonations'] = $this->donationRepository->getLastDonationsByInstitutionId($institution->id, self::MAX_LAST_DONATIONS);
        $data['institution'] = $institution;

        $donations = $this->donationRepository->getSumPointsLastSixMonthsGroupMonthByInstitutionId($institution->id);
        foreach ($donations as $donation) {
            $data['donationsByMonth']['label'][] = $donation['date'];
            $data['donationsByMonth']['data'][] = (int) $donation['points'];
        }

        if (empty($donations)) {
            $data['donationsByMonth']['label'][] = 'Instituição sem doações nos últimos meses';
            $data['donationsByMonth']['data'][] = 0;
        }

        return view($this->viewDir.'index-institution')->with(['page' => $this->page, 'data' => $data]);
    }

    private function dashboardCompany(User $user)
    {
        $company = $user->company;

        $data['lastCoupons'] = $this->couponRepository->getLastCouponsRescuedByCompanyId($company->id, self::MAX_LAST_COUPONS);
        $data['company'] = $company;

        $coupons = $this->couponRepository->getSumPointsLastSixMonthsGroupMonth($company->id);
        foreach ($coupons as $coupon) {
            $data['couponByMonth']['label'][] = $coupon['date'];
            $data['couponByMonth']['data'][] = (int) $coupon['points'];
        }

        if (empty($coupons)) {
            $data['couponByMonth']['label'][] = 'Empresa não gerou cupons nos últimos meses';
            $data['couponByMonth']['data'][] = 0;
        }

        return view($this->viewDir.'index-company')->with(['page' => $this->page, 'data' => $data]);
    }

    private function dashboardAdmin()
    {
        $data['lastCoupons'] = $this->adminPanelService->getLastCouponsCreated();
        $data['lastDonations'] = $this->adminPanelService->getLastDonations();

        $data['widgets'] = $this->adminPanelService->getWidgets();

        $data['donationsByMonth'] = $this->adminPanelService->getSumDonationPointsLastMonthsGroupMonth();
        $data['couponsByMonth'] = $this->adminPanelService->getSumCouponsPointsLastMonthsGroupMonth();

        return view($this->viewDir.'index-admin')->with(['page' => $this->page, 'data' => $data]);
    }
}

resources/views/dashboard/index-admin.blade.php
<x-admin title="{{ $page['titlePage'] }}" :breadcrumbs="$page['breadcrumb']">
    <div class="row">
        <div class="col-lg-3 col-6">
            <!-- small card -->
            <div class="small-box bg-info">
                <div class="inner">
                    <h3>{{ $data['widgets']['coupons_created'] }}</h3>

                    <p>Cupons gerados</p>
                </div>
                <div class="icon">
                    <i class="fas fa-ticket-alt"></i>
                </div>
                <a href="{{ route('coupons.index') }}" class="small-box-footer">
                    Ver cupons <i class="fas fa-arrow-circle-right"></i>
                </a>
            </div>
        </div>
        <!-- ./col -->
        <div class="col-lg-3 col-6">
            <!-- small card -->
            <div class="small-box bg-danger">
                <div class="inner">
                    <h3>{{ $data['widgets']['coupons_rescued'] }}</h3>

                    <p>Cupons resgatados</p>
                </div>
                <div class="icon">
                    <i class="fas fa-handshake"></i>
                </div>
                <a href="{{ route('coupons.index') }}" class="small-box-footer">
                    Ver cupons <i class="fas fa-arrow-circle-right"></i>
                </a>
            </div>
        </div>
        <!-- ./col -->
        <div class="col-lg-3 col-6">
            <!-- small card -->
            <div class="small-box bg-gradient-green ">
                <div class="inner">
                    <h3>{{ $data['widgets']['donations'] }}</h3>

                    <p>Doações realizadas</p>
                </div>
                <div class="icon">
                    <i class="fas fa-dove"></i>
                </div>
                <a href="{{ route('donations.index') }}" class="small-box-footer">
                    Doações realizadas <i class="fas fa-arrow-circle-right"></i>
                </a>
            </div>
        </div>
        <!-- ./col -->
        <div class="col-lg-3 col-6">
            <!-- small card -->
            <div class="small-box bg-warning">
                <div class="inner">
                    <h3>{{ $data['widgets']['created_users'] }}</h3>

                    <p>Usuários registrados</p>
                </div>
                <div class="icon">
                    <i class="fas fa-user-plus"></i>
                </div>
                <a href="{{ route('users.index') }}" class="small-box-footer">
                    Ver usuários <i class="fas fa-arrow-circle-right"></i>
                </a>
            </div>
        </div>
        <!-- ./col -->
    </div>
    <x-admin.internal-card>
        <div class="row row-cols-1 row-cols-md-2">
            <div class="col-md-6">
                <div class="card h-100">
                    <div class="card-header">
                        <h3 class="card-title">Últimos cupons criados</h3>
                    </div>
                    <div class="card-body">
                        <ul class="list-group mt-4">
                            @forelse($data['lastCoupons'] as $coupons)
                                <li class="list-group-item d-flex justify-content-between align-items-center">
                                    {{ $coupons->company->fantasy }}
                                    <span class="badge badge-primary badge-pill">{{ $coupons->points }}</span>
                                </li>
                            @empty
                                <li class="list-group-item d-flex justify-content-between align-items-center">
                                    Não existem cupons gerados.
                                </li>
                            @endforelse
                        </ul>
                    </div>
                </div>
            </div>
            <div class="col-md-6">
                <div class="card h-100">
                    <div class="card-header">
                        <h3 class="card-title">Últimas doações realizadas</h3>
                    </div>
                    <div class="card-body text-center">
                        <ul class="list-group mt-4">
                            @forelse($data['lastDonations'] as $donation)
                                <li class="list-group-item d-flex justify-content-between align-items-center">
                                    {{ $donation->user->name }}
                                    <span class="badge badge-primary badge-pill">{{ $donation->points }}</span>
                                </li>
                            @empty
                                <li class="list-group-item d-flex justify-content-between align-items-center">
                                    Não existem doações realizadas.
                                </li>
                            @endforelse
                        </ul>
                    </div>
                </div>
            </div>
        </div>
        <div class="row mt-3">
            <div class="col-md-6">
                <canvas id="chartDonations" style="width:100%; max-height: 500px;"></canvas>
            </div>
            <div class="col-md-6">
                <canvas id="chartCoupons" style="width:100%; max-height: 500px;"></canvas>
            </div>
        </div>
    </x-admin.internal-card>
    @push('scripts')
        <script src="https://cdnjs.cloudflare.com/ajax/libs/Chart.js/3.5.1/chart.min.js" integrity="sha512-Wt1bJGtlnMtGP0dqNFH1xlkLBNpEodaiQ8ZN5JLA5wpc1sUlk/O5uuOMNgvzddzkpvZ9GLyYNa8w2s7rqiTk5Q==" crossorigin="anonymous" referrerpolicy="no-referrer"></script>
        @toastr_render
        <script>
            $(function () {
                var donations =  {!! json_encode($data['donationsByMonth']) !!};
                var donationsXValues = donations.label;
                var donationsYValues = donations.data;
                var donationsSumPoints = donationsYValues.reduce((donationsAux, numberDonationsAux) => {
                    return donationsAux += numberDonationsAux;
                }, 0)
                var coupons =  {!! json_encode($data['couponsByMonth']) !!};
                var cuponsXValues = coupons.label;
                var cuponsYValues = coupons.data;
                var cuponsSumPoints = cuponsYValues.reduce((cuponsAux, numberCouponsAux) => {
                    return cuponsAux += numberCouponsAux;
                }, 0)

                const CHART_COLORS = {
                    green: 'rgb(75, 192, 192)',
                    blue: 'rgb(54, 162, 235)',
                    purple: 'rgb(153, 102, 255)',
                    yellow: 'rgb(255, 205, 86)',
                    red: 'rgb(255, 99, 132)',
                    orange: 'rgb(255, 159, 64)',
                    grey: 'rgb(201, 203, 207)'
                };

                new Chart("chartDonations", {
                    type: "doughnut",
                    data: {
                        labels: cuponsXValues,
                        datasets: [
                            {
                                label: 'Pontos',
                                data: cuponsYValues,
                                backgroundColor: Object.values(CHART_COLORS),
                            }
                        ]
                    },
                    options: {
                        responsive: true,
                        plugins: {
                            legend: {
                                position: 'top',
                            },
                            title: {
                                display: true,
                                text: `Pontos criados nos últimos 6 meses: ${cuponsSumPoints} `
                            }
                        }
                    },
                });
                new Chart("chartCoupons", {
                    type: "doughnut",
                    data: {
                        labels: donationsXValues,
                        datasets: [
                            {
                                label: 'Pontos',
                                data: donationsYValues,
                                backgroundColor: Object.values(CHART_COLORS),
                            }
                        ]
                    },
                    options: {
                        responsive: true,
                        plugins: {
                            legend: {
                                position: 'top',
                            },
                            title: {
                                display: true,
                                text: `Pontos doados nos últimos 6 meses: ${donationsSumPoints} `
                            }
                        }
                    },
                });
            });
        </script>
    @endpush
</x-admin>

resources/views/dashboard/index-donor.blade.php
<x-admin title="{{ $page['titlePage'] }}" :breadcrumbs="$page['breadcrumb']">
    <x-admin.internal-card>
        <div class="row row-cols-1 row-cols-md-2">
            <div class="col-md-6">
                <div class="card h-100">
                    <div class="card-header">
                        <h3 class="card-title">Novo cupom?</h3>
                    </div>
                    <div class="card-body text-center">
                        <x-form route="{{ route('rescued-coupon.store') }}" method="POST" enctype="multipart/form-data">
                            @include( $page['viewDir'].'donor.form')
                        </x-form>
                    </div>
                </div>
            </div>
            <div class="col-md-6">
                <div class="card h-100">
                    <div class="card-header">
                        <h3 class="card-title">Pontos</h3>
                    </div>
                    <div class="card-body text-center">
                        @if($data['availablePoints'] > 0)
                            <h1>Você possui o total de <span class="badge badge-info">{{ $data['availablePoints'] }}</span> pontos.</h1>
                            <a href="{{ route('donate.create') }}" class="btn btn-info btn-lg"
                               data-toggle="tooltip" data-placement="top" data-original-title="Doar" title="DOAR">
                                <i class="fas fa-hand-holding-heart"></i> Doar
                            </a>
                        @else
                            <h2>Opa, você ainda não possui pontos.</h2>
                            <h5>Efetue compras em nossos parceiros e ganhe cupons.</h5>
                            <a href="{{ route('donate.create') }}" class="btn btn-info btn-lg"
                               data-toggle="tooltip" data-placement="top" data-original-title="Doar" title="DOAR">
                                <i class="fas fas fa-store-alt"></i> Parceiros
                            </a>
                        @endif
                    </div>
                </div>
            </div>
        </div>
        <div class="row mt-3">
            <div class="col-md-12">
                <h2><span class="bd-content-title">Algumas instituições</span></h2>
            </div>
        </div>
        <div class="row">
            @forelse($data['institutions'] as $institution)
                <div class="col-md-4">
                    <div class="card h-100">
                        <img src="{{ $institution->coverImage }}" class="img elevation-2" style="height: auto; width: auto; max-width:100%; max-height:200px" alt="Capa da instituição">
                        <div class="card-body">
                            <h5 class="card-title">{{ $institution->name }}</h5>

                            <p class="card-text">{!! Str::of($institution->description)->before('<br />')->limit(500, '...') !!}</p>
                        </div>
                        <div class="card-footer clearfix">
                            <a href="{{ route('institutions.show', $institution->id) }}" class="btn btn-info float-right">Mais detalhes</a>
                        </div>
                    </div>
                </div>
            @empty
                <div class="col-md-12 text-center">
                    <p>Sem instituições cadastradas no momento.</p>
                </div>
            @endforelse
        </div>
        @if($data['institutions']->isNotEmpty())
            <div class="row mt-3">
                <div class="col-md-12 text-center">
                    <a href="{{ route('institutions.index') }}">Veja todas instituições cadastradas.</a>
                </div>
            </div>
        @endif
        <div class="row">
            <div class="col-md-12">
                <h2><span class="bd-content-title">Alguns parceiros</span></h2>
            </div>
        </div>
        <div class="row">
            @forelse($data['companies'] as $company)
                <div class="col-md-4">
                    <div class="card h-100">
                        <img src="{{ $company->coverImage }}" class="img elevation-2" style="height: auto; width: auto; max-width:100%; max-height:200px" alt="Capa da empresa">
                        <div class="card-body">
                            <h5 class="card-title">{{ $company->fantasy }}</h5>
                            <p class="card-text">{!! Str::of($company->description)->before('<br />')->limit(500, '...') !!}</p>
                        </div>
                        <div class="card-footer clearfix">
                            <a href="{{ route('companies.show', $company->id) }}" class="btn btn-info float-right">Mais detalhes</a>
                        </div>
                    </div>
                </div>
            @empty
                <div class="col-md-12 text-center">
                    <p>Sem empresas parceiras cadastradas no momento.</p>
                </div>
            @endforelse
        </div>
        @if($data['companies']->isNotEmpty())
            <div class="row mt-3">
                <div class="col-md-12 text-center">
                    <a href="{{ route('companies.index') }}">Veja todos parceiros cadastrados.</a>
                </div>
            </div>
        @endif

    </x-admin.internal-card>
    @push('scripts')
        @toastr_render
    @endpush
</x-admin>

resources/views/dashboard/index-institution.blade.php
<x-admin title="{{ $page['titlePage'] }}" :breadcrumbs="$page['breadcrumb']">
    <x-admin.internal-card>
        <div class="row row-cols-1 row-cols-md-2">
            <div class="col-md-6">
                <div class="card h-100">
                    <div class="card-body">
                        <a href="{{ route('institutions.show', $data['institution']->id) }}" class="btn btn-primary btn-lg"
                           data-toggle="tooltip" data-placement="top" data-original-title="Solicitar Resgate" title="Solicitar Resgate">
                            <i class="fas fa-eye"></i> Ver {{ $data['institution']->name }}
                        </a>
                        <a href="{{ route('institutions.edit', $data['institution']->id) }}" class="btn btn-info btn-lg"
                           data-toggle="tooltip" data-placement="top" data-original-title="Solicitar Resgate" title="Solicitar Resgate">
                            <i class="fa fa-edit"></i> Editar {{ $data['institution']->name }}
                        </a>
                        <ul class="list-group mt-4">
                            <li class="list-group-item active d-flex justify-content-between align-items-center">
                                Últimas doações
                            </li>
                            @forelse($data['lastDonations'] as $donation)
                                <li class="list-group-item d-flex justify-content-between align-items-center">
                                    {{ $donation->user->name }}
                                    <span class="badge badge-primary badge-pill">{{ $donation->points }}</span>
                                </li>
                            @empty
                                <li class="list-group-item d-flex justify-content-between align-items-center">
                                    Essa instituição ainda não recebeu doações.
                                </li>
                            @endforelse
                        </ul>
                    </div>
                </div>
            </div>
            <div class="col-md-6">
                <div class="card h-100">
                    <div class="card-header">
                        <h3 class="card-title">Pontos recebidos</h3>
                    </div>
                    <div class="card-body text-center">
                        @if($data['availablePoints'] > 0)
                            <h1>Você possui o total de <span class="badge badge-info">{{ $data['availablePoints'] }}</span> pontos para resgate.</h1>
                            <a href="{{ route('rescues.create') }}" class="btn btn-info btn-lg"
                               data-toggle="tooltip" data-placement="top" data-original-title="Solicitar Resgate" title="Solicitar Resgate">
                                <i class="fas fa-donate"></i> Solicitar Resgate
                            </a>
                        @else
                            <h2>Opa, você ainda não tem pontos disponíveis.</h2>
                            <h5>Ajude divulgando UnePontos e sua instituição nas redes sociais.</h5>
                        @endif
                    </div>
                </div>
            </div>
        </div>
        <div class="row mt-3">
            <div class="col-md-12">
                <canvas id="chartPoints" style="width:100%; max-height: 500px;"></canvas>
            </div>
        </div>
    </x-admin.internal-card>
    @push('scripts')
        <script src="https://cdnjs.cloudflare.com/ajax/libs/Chart.js/3.5.1/chart.min.js" integrity="sha512-Wt1bJGtlnMtGP0dqNFH1xlkLBNpEodaiQ8ZN5JLA5wpc1sUlk/O5uuOMNgvzddzkpvZ9GLyYNa8w2s7rqiTk5Q==" crossorigin="anonymous" referrerpolicy="no-referrer"></script>
        @toastr_render
        <script>
            $(function () {
                var donations =  {!! json_encode($data['donationsByMonth']) !!};
                var xValues = donations.label;
                var yValues = donations.data;
                var sumPoints = yValues.reduce((acumulador, numero) => {
                    return acumulador += numero;
                }, 0)

                const CHART_COLORS = {
                    green: 'rgb(75, 192, 192)',
                    blue: 'rgb(54, 162, 235)',
                    purple: 'rgb(153, 102, 255)',
                    yellow: 'rgb(255, 205, 86)',
                    red: 'rgb(255, 99, 132)',
                    orange: 'rgb(255, 159, 64)',
                    grey: 'rgb(201, 203, 207)'
                };

                new Chart("chartPoints", {
                    type: "doughnut",
                    data: {
                        labels: xValues,
                        datasets: [
                            {
                                label: 'Pontos',
                                data: yValues,
                                backgroundColor: Object.values(CHART_COLORS),
                            }
                        ]
                    },
                    options: {
                        responsive: true,
                        plugins: {
                            legend: {
                                position: 'top',
                            },
                            title: {
                                display: true,
                                text: `Pontos recebidos nos últimos 6 meses: ${sumPoints} `
                            }
                        }
                    },
                });
            });
        </script>
    @endpush
</x-admin>

resources/views/dashboard/index.blade.php
<x-admin title="{{ $page['titlePage'] }}" :breadcrumbs="$page['breadcrumb']">
    <x-admin.internal-card>
        Conteudo da dashboard.
    </x-admin.internal-card>
    @push('scripts')
        @toastr_render
    @endpush
</x-admin>